#include <stdio.h>
#include <stdlib.h>

char *rl_readline_name;
FILE *rl_instream;


static int initialised;
static char fx4;
static char fkeys[8];


void
using_history (void)
{
}
void
add_history (void)
{
}
void
unstifle_history (void)
{
}
void
stifle_history (void)
{
}


/* On exit.  */
static void
restore (void)
{
  int i;
  _kernel_osbyte (4, fx4, 0);
  for (i = 0; i < 8; ++i)
    _kernel_osbyte (221 + i, fkeys[i], 0);
}


char *
readline (const char *prompt)
{
  int length, allocated, c;
  char *buffer;
  int bin;

  if (ferror (rl_instream) || feof (rl_instream))
    return 0;

  bin = rl_instream->__flag && 4; /* binary? */
  length = 0;
  buffer = malloc (allocated = 1024);
  if (!buffer)
    {
      fprintf (stderr, "%s: readline: out of memory\n", rl_readline_name);
      exit (2);
    }

  if (!initialised)
    {
      initialised = 1;
      fx4 = (char) _kernel_osbyte (237, 0, 255);
      for (c = 0; c < 7; ++c)
	fkeys[c] = (char) _kernel_osbyte (221 + c, 0, 255);
      atexit (restore);
      _kernel_osbyte (4, 2, 0);
      for (c = 0; c < 7; ++c)
	_kernel_osbyte (221 + c, 2, 0);
    }

  printf ("%s", prompt);
  fflush (stdout);

  rl_instream->__flag |= 4; /* -> binary */

  for (;;)
    {
      c = fgetc (rl_instream);
      if (c == EOF)
	goto finish;
      if (c == 0)
	{
	  c = fgetc (rl_instream) | 256;
	  if (c == EOF)
	    goto finish;
	}
      switch (c)
	{
	case 4:			/* EOF */
	  rl_instream->__flag |= _IOEOF;
	  goto finish;
	case 8:			/* Backspace */
	case 127:		/* Delete */
	  if (length)
	    {
	      length--;
	      putchar (127);
	    }
	  break;
	case 10:		/* Ctrl J */
	case 13:		/* Return */
	  goto finish;
	case 21:		/* Ctrl U */
	  while (length--)
	    putchar (127);
	  break;
	default:
	  if (c >= 32 && c <= 255)
	    {
	      buffer[length++] = c;
	      putchar (c);
	      if (length == allocated)
		{
		  buffer = realloc (buffer, allocated += 1024);
		  if (!buffer)
		    {
		      fprintf (stderr, "%s: readline: out of memory\n",
			       rl_readline_name);
		      exit (2);
		    }
		}
	    }
	  else
	    putchar (7);	/* bell */
	}
    }

finish:
  if (!bin)
    rl_instream->__flag &= ~4; /* -> text */
  puts ("");

  buffer[length] = 0;
  return buffer;
}
